# coding: utf-8

"""
Copyright 2015 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems


class ChangelistRequest(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        ChangelistRequest - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'description': 'str',
            'stream': 'str',
            'actions': 'list[ChangelistAction]'
        }

        self.attribute_map = {
            'description': 'description',
            'stream': 'stream',
            'actions': 'actions'
        }

        self._description = None
        self._stream = None
        self._actions = None

    @property
    def description(self):
        """
        Gets the description of this ChangelistRequest.


        :return: The description of this ChangelistRequest.
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """
        Sets the description of this ChangelistRequest.


        :param description: The description of this ChangelistRequest.
        :type: str
        """
        self._description = description

    @property
    def stream(self):
        """
        Gets the stream of this ChangelistRequest.
        Optional stream ID to use in case you want to edit files in a stream.

        :return: The stream of this ChangelistRequest.
        :rtype: str
        """
        return self._stream

    @stream.setter
    def stream(self, stream):
        """
        Sets the stream of this ChangelistRequest.
        Optional stream ID to use in case you want to edit files in a stream.

        :param stream: The stream of this ChangelistRequest.
        :type: str
        """
        self._stream = stream

    @property
    def actions(self):
        """
        Gets the actions of this ChangelistRequest.


        :return: The actions of this ChangelistRequest.
        :rtype: list[ChangelistAction]
        """
        return self._actions

    @actions.setter
    def actions(self, actions):
        """
        Sets the actions of this ChangelistRequest.


        :param actions: The actions of this ChangelistRequest.
        :type: list[ChangelistAction]
        """
        self._actions = actions

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other): 
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """ 
        Returns true if both objects are not equal
        """
        return not self == other

