# coding: utf-8

"""
Copyright 2015 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems


class LabelCommand(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        LabelCommand - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'label': 'str',
            'owner': 'str',
            'update': 'datetime',
            'access': 'datetime',
            'description': 'str',
            'options': 'str',
            'revision': 'str',
            'view': 'list[str]',
            'server_id': 'str'
        }

        self.attribute_map = {
            'label': 'label',
            'owner': 'owner',
            'update': 'update',
            'access': 'access',
            'description': 'description',
            'options': 'options',
            'revision': 'revision',
            'view': 'view',
            'server_id': 'serverID'
        }

        self._label = None
        self._owner = None
        self._update = None
        self._access = None
        self._description = None
        self._options = None
        self._revision = None
        self._view = None
        self._server_id = None

    @property
    def label(self):
        """
        Gets the label of this LabelCommand.
        The label name.

        :return: The label of this LabelCommand.
        :rtype: str
        """
        return self._label

    @label.setter
    def label(self, label):
        """
        Sets the label of this LabelCommand.
        The label name.

        :param label: The label of this LabelCommand.
        :type: str
        """
        self._label = label

    @property
    def owner(self):
        """
        Gets the owner of this LabelCommand.
        The label’s owner.\nBy default, the user who created the label.\nOnly the owner of a label can update which files are tagged with the label.\n\nThe specified owner does not have to be a Perforce user.\nYou might want to use an arbitrary name if the user does not yet exist, or if you have deleted the user and need a placeholder until you can assign the spec to a new user.

        :return: The owner of this LabelCommand.
        :rtype: str
        """
        return self._owner

    @owner.setter
    def owner(self, owner):
        """
        Sets the owner of this LabelCommand.
        The label’s owner.\nBy default, the user who created the label.\nOnly the owner of a label can update which files are tagged with the label.\n\nThe specified owner does not have to be a Perforce user.\nYou might want to use an arbitrary name if the user does not yet exist, or if you have deleted the user and need a placeholder until you can assign the spec to a new user.

        :param owner: The owner of this LabelCommand.
        :type: str
        """
        self._owner = owner

    @property
    def update(self):
        """
        Gets the update of this LabelCommand.
        The date the label specification was last modified.

        :return: The update of this LabelCommand.
        :rtype: datetime
        """
        return self._update

    @update.setter
    def update(self, update):
        """
        Sets the update of this LabelCommand.
        The date the label specification was last modified.

        :param update: The update of this LabelCommand.
        :type: datetime
        """
        self._update = update

    @property
    def access(self):
        """
        Gets the access of this LabelCommand.
        The date and time the label was last accessed, either by running p4 labelsync on the label, or by otherwise referring to a file with the label revision specifier @label.\n(Note: Reloading a label with p4 reload does not affect the access time.)

        :return: The access of this LabelCommand.
        :rtype: datetime
        """
        return self._access

    @access.setter
    def access(self, access):
        """
        Sets the access of this LabelCommand.
        The date and time the label was last accessed, either by running p4 labelsync on the label, or by otherwise referring to a file with the label revision specifier @label.\n(Note: Reloading a label with p4 reload does not affect the access time.)

        :param access: The access of this LabelCommand.
        :type: datetime
        """
        self._access = access

    @property
    def description(self):
        """
        Gets the description of this LabelCommand.
        An optional description of the label’s purpose.

        :return: The description of this LabelCommand.
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """
        Sets the description of this LabelCommand.
        An optional description of the label’s purpose.

        :param description: The description of this LabelCommand.
        :type: str
        """
        self._description = description

    @property
    def options(self):
        """
        Gets the options of this LabelCommand.
        Options to control behavior and storage location of labels.\n\n- locked or unlocked: If the label is locked, the list of files tagged with the label cannot be changed with p4 labelsync.\n\n- autoreload or noautoreload. For static labels, if noautoreload is set, the label is stored in db.label, and if autoreload is set, it is stored in the unload depot. This option is ignored for automatic labels. Storing labels in the unload depot can improve performance on sites that make extremely heavy use of labels.

        :return: The options of this LabelCommand.
        :rtype: str
        """
        return self._options

    @options.setter
    def options(self, options):
        """
        Sets the options of this LabelCommand.
        Options to control behavior and storage location of labels.\n\n- locked or unlocked: If the label is locked, the list of files tagged with the label cannot be changed with p4 labelsync.\n\n- autoreload or noautoreload. For static labels, if noautoreload is set, the label is stored in db.label, and if autoreload is set, it is stored in the unload depot. This option is ignored for automatic labels. Storing labels in the unload depot can improve performance on sites that make extremely heavy use of labels.

        :param options: The options of this LabelCommand.
        :type: str
        """
        self._options = options

    @property
    def revision(self):
        """
        Gets the revision of this LabelCommand.
        An optional revision specification for an automatic label.\n\nIf you use the # character to specify a revision number, you must use quotes around it in order to ensure that the # is parsed as a revision specifier, and not as a comment field in the form.

        :return: The revision of this LabelCommand.
        :rtype: str
        """
        return self._revision

    @revision.setter
    def revision(self, revision):
        """
        Sets the revision of this LabelCommand.
        An optional revision specification for an automatic label.\n\nIf you use the # character to specify a revision number, you must use quotes around it in order to ensure that the # is parsed as a revision specifier, and not as a comment field in the form.

        :param revision: The revision of this LabelCommand.
        :type: str
        """
        self._revision = revision

    @property
    def view(self):
        """
        Gets the view of this LabelCommand.
        A list of depot files that can be tagged with this label.\nNo files are actually tagged until `p4 labelsync` is invoked.\n\nUnlike client views or branch views, which map one set of files to another, label views consist of a simple list of depot files.

        :return: The view of this LabelCommand.
        :rtype: list[str]
        """
        return self._view

    @view.setter
    def view(self, view):
        """
        Sets the view of this LabelCommand.
        A list of depot files that can be tagged with this label.\nNo files are actually tagged until `p4 labelsync` is invoked.\n\nUnlike client views or branch views, which map one set of files to another, label views consist of a simple list of depot files.

        :param view: The view of this LabelCommand.
        :type: list[str]
        """
        self._view = view

    @property
    def server_id(self):
        """
        Gets the server_id of this LabelCommand.
        If set, restricts usage of the label to the named server.\nIf unset, this label may be used on any server.

        :return: The server_id of this LabelCommand.
        :rtype: str
        """
        return self._server_id

    @server_id.setter
    def server_id(self, server_id):
        """
        Sets the server_id of this LabelCommand.
        If set, restricts usage of the label to the named server.\nIf unset, this label may be used on any server.

        :param server_id: The server_id of this LabelCommand.
        :type: str
        """
        self._server_id = server_id

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other): 
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """ 
        Returns true if both objects are not equal
        """
        return not self == other

